#include <stdlib.h>
#include <stdio.h>
#include <jasper/jasper.h>

#if defined (CRAY)

#define info_jpeg2000 INFO_JPEG2000
#define decode_jpeg2000 DECODE_JPEG2000

#elif defined (__sgi) || defined (__sun) || defined (__alpha) || defined (__linux)

#define info_jpeg2000 info_jpeg2000_
#define decode_jpeg2000 decode_jpeg2000_

#elif defined (IBM) || defined (HP)

#define info_jpeg2000 info_jpeg2000
#define decode_jpeg2000 decode_jpeg2000

#endif


void info_jpeg2000(char *buffer, int *length, int *width, int *height, jas_image_t **image, jas_stream_t **instream) {
  int fmtid;
  int numcmpts;
  int depth;

  /* Initialize jasper stuff */
  jas_init();

    /* open the buffer */
  if ( ! (*instream = jas_stream_memopen(buffer, *length))) {
    fprintf(stderr, "cannot open input buffer\n");
    exit(1);
  }

  /* Get image format */
  if ((fmtid = jas_image_getfmt(*instream)) < 0) {
    fprintf(stderr, "decode_jpeg2000:  unknown image format:  fmtid = %i\n", fmtid);
    return;
    exit (1);
  }

  /* Decode the image. */
  if (!(*image = jas_image_decode(*instream, fmtid, 0))) {
    fprintf(stderr, "cannot load image\n");
    exit (1);
  }

  numcmpts = jas_image_numcmpts(*image);
  *width = jas_image_cmptwidth(*image, 0);
  *height = jas_image_cmptheight(*image, 0);
  depth = jas_image_cmptprec(*image, 0);

}


void decode_jpeg2000(jas_image_t **image, jas_stream_t **instream, int *width, int *height, long *buf) {
  /* Call info_jpeg2000_ before calling decode_jpeg2000_ */
  jas_matrix_t data;
  int ierr;

  ierr = jas_image_readcmpt2(*image, 0, 0, 0, *width, *height, buf);
  /* Close the image file. */
  jas_stream_close(*instream);
  jas_image_destroy(*image);
  jas_image_clearfmts();

}
