#!/usr/bin/env tcsh

   set rundir = /d2/kmanning/collect
   set namelist_template = /home/kmanning/COLLECT_DATA/run/namelist.template
   set exe = /home/kmanning/COLLECT_DATA/consolidate_grib.exe

   mkdir -p ${rundir}
   cd ${rundir}

#
#  Set the date/time information (optionally from command-line arguments)
#

   if ( ${#argv} == 0) then

      set nowdate = `date +%Y-%m-%d_00`
      set start_hdate = `${HOME}/bin/geth_newdate ${nowdate} -72`
      set end_hdate   = `${HOME}/bin/geth_newdate ${start_hdate} 120`

   else  
      set yyyy = `echo ${1} | cut -b 1-4`
      set mm =   `echo ${1} | cut -b 5-6`
      set dd =   `echo ${1} | cut -b 7-8`
      set nowdate = ${yyyy}-${mm}-${dd}_00
      echo "nowdate = $nowdate"
    
      if ( $#argv == 2 ) then
         set start_hdate = `${HOME}/bin/geth_newdate ${nowdate} ${2}`
         echo "start_hdate = $start_hdate"
         @ eh = ${2} + 24
         set end_hdate   = `${HOME}/bin/geth_newdate ${start_hdate} ${eh}`
         echo "end_hdate = $end_hdate"
      else
         set start_hdate = `${HOME}/bin/geth_newdate ${nowdate} -48`
         echo "start_hdate = $start_hdate"
         set end_hdate   = `${HOME}/bin/geth_newdate ${start_hdate} 72`
         echo "end_hdate = $end_hdate"
      endif
   endif

#
#  Set up a new namelist with the updated date/time information
#

   m4 -D__START_HDATE__=${start_hdate} -D__END_HDATE__=${end_hdate} ${namelist_template} >! namelist.input

#
#  Run the program
#

   ${exe}
   

   
